#include<bits/stdc++.h>
#define LL long long
#define rep(i,a,b,g) for(LL i=a;i<=b;i+=g)
#define repn(i,a,b,g) for(LL i=a;i<b;i+=g)
#define rem(i,a,b,g) for(LL i=a;i>=b;i-=g)
using namespace std;
LL n,u,v,q,l,r,k;
LL fa[500010][21],dep[500010],mc,t;
vector<LL>e[500010];
void dfs(LL no,LL ff)
{
	dep[no]=dep[ff]+1; 
	for(LL i:e[no])
	{
		if(i==ff)continue;
		dfs(i,no);
		fa[i][0]=no;
	}
}
void ycl()
{
	rep(i,1,19,1)
	{
		rep(j,1,n,1)
		{
			fa[j][i]=fa[fa[j][i-1]][i-1];
		}
	}
}
LL LCA(LL a,LL b)
{
	if(a==b)return a;
	if(dep[a]<dep[b])swap(a,b);
	rem(i,19,0,1)
	{
		if(dep[fa[a][i]]>=dep[b])a=fa[a][i];
	}
	if(a==b)return a;
	rem(i,19,0,1)
	{
		if(fa[a][i]!=fa[b][i])
		{
			a=fa[a][i];
			b=fa[b][i];
		}
	}
	return fa[a][0];
}
int main()
{
	freopen("query.in","r",stdin);
	freopen("query.out","w",stdout);
	scanf("%lld",&n);
	repn(i,1,n,1)
	{
		scanf("%lld%lld",&u,&v);
		e[u].push_back(v);
		e[v].push_back(u);
	}
	dfs(1,0);
	ycl();
	scanf("%lld",&q);
	while(q--)
	{
		scanf("%lld%lld%lld",&l,&r,&k);
		mc=0;
		rep(i,l,r,1)
		{
			rep(j,i+k-1,r,1)
			{
				if(i==j)t=i;
				else t=LCA(i,i+1);
				rep(o,i+1,j,1)
				{
					t=LCA(t,o);
				}
				mc=max(mc,dep[t]);
			}
		}
		printf("%lld\n",mc);
	}
	return 0;
}
/*
11:00 maybe 8 pts, go solve T2
11:27 try 8 pts baoli
12:06 small yangli AC
12:07 find that it can't 8 pts, so rp++ that shuju is waterful
12:08 go try T3
*/
/*
6
5 6
6 1
6 2
2 3
2 4
3
2 5 2
1 4 1
1 6 3
*/
/*
follooooooooooow me!
me:dzd is love!
you:dzd is love!!
me:dzd is power!
you:dzd is power!!

rp++rp++rp++rp++rp++rp++rp++rp++rp++rp++rp++rp++rp++rp++rp++rp++rp++rp++rp++rp++rp++rp++rp++rp++rp++rp++rp++rp++rp++rp++rp++rp++

baoli don't fail me now

baoli wo ai ni
baoli wo ai ni
baoli wo ai ni
baoli wo ai ni
baoli wo ai ni
baoli wo ai ni
baoli wo ai ni
baoli wo ai ni
baoli wo ai ni
baoli wo ai ni
baoli wo ai ni
baoli wo ai ni
baoli wo ai ni
baoli wo ai ni
baoli wo ai ni
baoli wo ai ni
baoli wo ai ni
baoli wo ai ni
baoli wo ai ni
baoli wo ai ni
baoli wo ai ni
baoli wo ai ni
baoli wo ai ni
baoli wo ai ni
baoli wo ai ni
baoli wo ai ni
baoli wo ai ni
baoli wo ai ni
baoli wo ai ni
baoli wo ai ni
baoli wo ai ni
baoli wo ai ni
baoli wo ai ni
baoli wo ai ni
baoli wo ai ni
baoli wo ai ni
baoli wo ai ni
baoli wo ai ni
baoli wo ai ni
baoli wo ai ni
baoli wo ai ni
baoli wo ai ni
baoli wo ai ni
baoli wo ai ni
baoli wo ai ni
baoli wo ai ni
baoli wo ai ni
baoli wo ai ni
baoli wo ai ni
baoli wo ai ni
baoli wo ai ni
baoli wo ai ni
baoli wo ai ni
baoli wo ai ni
baoli wo ai ni
baoli wo ai ni
baoli wo ai ni
*/
